
#include <fx2.h>


static void mdelay1 (void) _naked
{
	/* 1ms delay at 12Mhz:
	 * the delay loop has 10 instruction cycles, hance we need
	 * 1e-3 / (1/12e6 * 4 * 10) = 300 iterations */
	_asm
	push	acc
	push	dpl
	push	dph
	push	_DPS
	mov	_DPS, #(0)
	mov	dptr, #(0xffff - 300)
1$:	inc	dptr	; 3 cycles
	mov	a, dpl	; 2 cycles
	orl	a, dph	; 2 cycles
	jnz	1$	; 3 cycles
	pop	_DPS
	pop	dph
	pop	dpl
	pop	acc
	ret
	_endasm;
}

void mdelay (short milliseconds) critical
{
	if ((CPUCS & 0x18) == 0x10)
		milliseconds *= 4;	/* 48MHz */
	else if ((CPUCS & 0x18) == 0x08)
		milliseconds *= 2;	/* 24MHz */
	/* else: 12MHz */

	while (milliseconds--)
		mdelay1();
}

