; DVB-T USB2 firmware for Cypress EZ-USB FX2
; autovector irq handlers

	.module irq

; there are 27 autovecored USB irqs (via INT2 / vector 0x43,
; cf. section 4.5 of the FX2 user's manual)
; and 14 autovecored GPIF/FIFO irqs (INT4 / 0x53
; cf. section 4.7).
; they are dispatched via a simple jump table

; the interrupt routines must be defined externally as "interrupt 0":
	.globl _usb_sudav_irq
	.globl _usb_suspend_irq
	.globl _usb_usbreset_irq
	.globl _usb_hsgrant_irq
;	.globl _usb_ep1in_irq
;	.globl _usb_ep1out_irq
	.globl _buggy_irq_jump
;	.globl _usb_ep2pf_irq
;	.globl _usb_ep4pf_irq
;	.globl _usb_ep6pf_irq
;	.globl _usb_ep8pf_irq
;	.globl _usb_ep2ff_irq
;	.globl _gpif_wf_irq

; jump table, starts on a page boundary
	.area	AUTOVECTOR	(CODE,ABS)
	.org	0x1f00
_autovector_jump_table_usb::
_autovector_jump_table_gpif::

	ljmp _usb_sudav_irq
	.db	0
	ljmp _buggy_irq_jump
	.db	0
	ljmp _buggy_irq_jump
	.db	0
	ljmp _usb_suspend_irq
	.db	0
	ljmp _usb_usbreset_irq
	.db	0
	ljmp _usb_hsgrant_irq
	.db	0
	ljmp _buggy_irq_jump
	.db	0
	.db	0,0,0,0
	ljmp _buggy_irq_jump
	.db	0
	ljmp _buggy_irq_jump
	.db	0
	ljmp _buggy_irq_jump
;	ljmp _usb_ep1in_irq
	.db	0
	ljmp _buggy_irq_jump
;	ljmp _usb_ep1out_irq
	.db	0
	ljmp _buggy_irq_jump
	.db	0
	ljmp _buggy_irq_jump
	.db	0
	ljmp _buggy_irq_jump
	.db	0
	ljmp _buggy_irq_jump
	.db	0
	ljmp _buggy_irq_jump
	.db	0
	.db	0,0,0,0
	ljmp _buggy_irq_jump
	.db	0
	ljmp _buggy_irq_jump
	.db	0
	ljmp _buggy_irq_jump
	.db	0
	ljmp _buggy_irq_jump
	.db	0
	ljmp _buggy_irq_jump
	.db	0
	ljmp _buggy_irq_jump
	.db	0
	ljmp _buggy_irq_jump
	.db	0
	.db	0,0,0,0
	.db	0,0,0,0
	.db	0,0,0,0
	ljmp _buggy_irq_jump
	.db	0
	ljmp _buggy_irq_jump
	.db	0
	ljmp _buggy_irq_jump
	.db	0
	ljmp _buggy_irq_jump

	.org	0x1f80
	ljmp _buggy_irq_jump	;_usb_ep2pf_irq
	.db	0
	ljmp _buggy_irq_jump	;_usb_ep4pf_irq
	.db	0
	ljmp _buggy_irq_jump	;_usb_ep6pf_irq
	.db	0
	ljmp _buggy_irq_jump	;_usb_ep8pf_irq
	.db	0
	ljmp _buggy_irq_jump
	.db	0
	ljmp _buggy_irq_jump
	.db	0
	ljmp _buggy_irq_jump
	.db	0
	ljmp _buggy_irq_jump
	.db	0
	ljmp _buggy_irq_jump	;_usb_ep2ff_irq
	.db	0
	ljmp _buggy_irq_jump
	.db	0
	ljmp _buggy_irq_jump
	.db	0
	ljmp _buggy_irq_jump
	.db	0
	ljmp _buggy_irq_jump
	.db	0
	ljmp _gpif_wf_irq


; eof
