
#include <fx2.h>
#include "irq.h"
#include "types.h"
#include "delay.h"
#include "bug.h"
#include "jtag.h"
#include "usb_ep1.h"

//static bit ep1in_space_available = 1; 
//static bit ep1out_data_available = 0; 


void usb_ep1_init (void)
{

	EP1INCFG = 0xa0;	/*  bulk EP, enable */
	EP1OUTCFG = 0xa0;       /*  bulk EP, enable */

//	EXIF &= ~0x10;
//	EPIRQ = 0x0c;		/*  clear pending irqs */
//	EPIE |= 0x0c;		/*  enable EP1 in+out irq */


	syncdelay();
	EP1OUTBC = 0;	   /*  arm EP1out */
	syncdelay();
}


/*
#pragma SAVE
#pragma NOIV

void usb_ep1in_irq (void) interrupt 8 using 1
{
	ep1in_space_available = 1;
	EXIF &= ~0x10;
	EPIRQ = 0x04;
}


void usb_ep1out_irq (void) interrupt 8 using 1
{
	ep1out_data_available = 1;
	EXIF &= ~0x10;
	EPIRQ = 0x08;
}

#pragma RESTORE
*/


/**
 *  EP1 out (64bytes)
 *
 *    i2c write (i2c send_bytes):
 *
 *      { cmd == USB_EP1_CMD_I2C_WRITE,
 *	((address << 1) | (read request bit)),
 *	len,
 *	data (up to 61bytes for i2c write transfers)
 *      }
 *
 *    PID table reset, clear all filter bits:
 *
 *      { cmd == USB_EP1_CMD_PID_TABLE_RESET }
 *
 *    PID table setup:
 *
 *      { cmd == USB_EP1_CMD_PID_SETUP,
 *	  PID:hi,
 *	  PID:lo,
 *	  (enable == 1 | disable == 0)
 *      }
 *
 *    Isotransfer control:
 *
 *      { cmd == USB_EP1_CMD_CONTROL_ISO_TRANSFER,
 *	  (enable iso stream == 1 | disable == 0)
 *      }
 *
 *
 *  EP1 in (64bytes)
 *
 *    i2c status+read (i2c recv_bytes):
 *
 *    { status (I2C_OK, I2C_NACK, I2C_BUSERROR),
 *      data (up to 61bytes for i2c read transfers)
 *    }
 */
void usb_ep1_process_request (void)
{
	u8 retlen = 0;

	if ((EP01STAT & 0x06) != 0x00)	/* still busy? */
		return;

	retlen = handle_jtag();	
		
	syncdelay();
	EP1OUTBC = 0;		/*  re-arm EP1out */
	syncdelay();

	syncdelay();
	EP1INBC = retlen;
	syncdelay();

}
