library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity s2usb is
    Port ( switch : in  STD_LOGIC_VECTOR (7 downto 0);
           -- button : in  STD_LOGIC;
			  clock : in STD_LOGIC;
			  usb_full : in  STD_LOGIC;
           usb_data : inout  STD_LOGIC_VECTOR (7 downto 0);
           usb_fifo_addr : out  STD_LOGIC_VECTOR (1 downto 0);
           usb_write : out  STD_LOGIC;
           usb_pktend : out  STD_LOGIC;
			  usb_cs : out STD_LOGIC;
			  usb_rd : out std_logic;
			  usb_oe : out std_logic;
			  led : out std_logic_vector(7 downto 0)
			  );
end s2usb;

architecture Behavioral of s2usb is

signal prescaler : std_logic_vector(2 downto 0);

begin

usb_send : process(clock)
begin

	if(clock'event) and (clock='1') then
		prescaler <= prescaler + 1;
	end if;

end process;

usb_fifo_addr <= "00" when switch(7)='1' else "10"; -- ep2/6

usb_data <= switch when switch(7)='1' else (others => 'Z');

usb_cs <= '0';

usb_pktend <= '1';

usb_write <= prescaler(2) when switch(7)='1' else '1';

led(7 downto 1) <= switch(7 downto 1) when switch(7)='1' else usb_data(7 downto 1);
led(0) <= usb_full;

usb_rd <= '1' when switch(7)='1' else prescaler(2);
usb_oe <= '1' when switch(7)='1' else prescaler(2);


end Behavioral;
